#include "stdafx.h"
#include "deltapak.h"
#include "lara_states.h"

extern cutscene_parameters* CutParameters;

void SetCutscene(long id);
void CallTrigger(short id);
void ActivateOrganizer();
void CallOrganizerTrigger(StrScriptOrganizer* organizer, long frame);
void StopTracks();
void StartTracks();
void PlayAudio(long audio);
void StopAudio();

char cutseq_busy_timeout;
camera_type GLOBAL_oldcamtype;
PACKNODE* ext_pnodes;
long cutrot;
long old_orgx;
long old_orgy;
long old_orgz;

void handle_cutseq_triggering(long name)
{
	AIOBJECT* ai;
	long n, goin, fuck;

	if (!cutseq_num)
		return;

	if (!cutseq_trig)
	{
		if (lara.gun_type == WEAPON_FLARE || lara.gun_status != LG_NO_ARMS && lara.gun_status != LG_HANDS_BUSY)
			lara.gun_status = LG_UNDRAW_GUNS;

		cutseq_trig = 1;
		memset(cutseq_meshswapbits, 0, sizeof(cutseq_meshswapbits));
		cutseq_busy_timeout = 50;
		memset(cutseq_meshbits, -1, sizeof(cutseq_meshbits));

		if (CutParameters->cinematic_bars)
			SetFadeClip(28, 1);

		ScreenFading = 0;

		if (CutParameters->fade)
			SetScreenFadeOut(16, 0);
		else
			ScreenFadedOut = 1;
	}
	else if (cutseq_trig == 1)
	{
		fuck = 0;
		n = lara_item->current_anim_state;

		if (ScreenFadedOut)
		{
			cutseq_busy_timeout--;

			if (!cutseq_busy_timeout)
				fuck = 1;

			if (lara.gun_status == LG_HANDS_BUSY || lara.gun_status == LG_NO_ARMS && !lara.flare_control_left ||
				n == AS_ALL4S || n == AS_CRAWL || n == AS_ALL4TURNL || n == AS_ALL4TURNR || n == AS_CRAWLBACK || fuck)
			{
				lara.gun_type = WEAPON_NONE;
				lara.request_gun_type = WEAPON_NONE;
				lara.gun_status = LG_NO_ARMS;
				old_lara_holster = lara.holster;
				lara.holster = lara.pistols_type_carried == W_NONE ? LARA_HOLSTERS : LARA_HOLSTERS_PISTOLS;
				lara.mesh_ptrs[LM_LHAND] = meshes[objects[0].mesh_index + 2 * LM_LHAND];
				lara.mesh_ptrs[LM_RHAND] = meshes[objects[0].mesh_index + 2 * LM_RHAND];
				lara.left_arm.frame_number = 0;
				lara.right_arm.frame_number = 0;
				lara.target = 0;
				lara.right_arm.lock = 0;
				lara.left_arm.lock = 0;
				lara_item->goal_anim_state = AS_STOP;
				lara_item->current_anim_state = AS_STOP;
				lara_item->frame_number = anims[ANIM_STOP].frame_base;
				lara_item->anim_number = ANIM_STOP;
				lara_item->speed = 0;
				lara_item->fallspeed = 0;
				lara_item->gravity_status = 0;
				lara.back_gun = 0;

				if (lara.weapon_item != NO_ITEM)
				{
					KillItem(lara.weapon_item);
					lara.weapon_item = NO_ITEM;
				}

				StopTracks();
				goin = cutseq_num;
				numnailed = 0;
				GLOBAL_oldcamtype = camera.type;
				ScreenFading = 0;

				if (CutParameters->fade)
					SetScreenFadeIn(16);

				Load_and_Init_Cutseq(goin);
				cutseq_trig = 2;

				if (CutParameters->init_trigger != -1)
					CallTrigger(CutParameters->init_trigger);

				if (CutParameters->organizer)
					ActivateOrganizer();

				cutrot = CutParameters->rot;

				if (GLOBAL_cutme->audio_track != -1)
					PlayAudio(GLOBAL_cutme->audio_track);
			}
		}
	}
	else if (cutseq_trig == 3)
	{
		if (CutParameters->fade)
			SetScreenFadeOut(16, 1);
		else
			ScreenFadedOut = 1;

		cutseq_trig = 4;
	}
	else if (cutseq_trig == 4)
	{
		if (ScreenFadedOut && GLOBAL_cutseq_frame == GLOBAL_numcutseq_frames)
		{
			StopAudio();
			ScreenFadedOut = 0;
			numnailed = 0;

			if (CutParameters->end_trigger != -1)
				CallTrigger(CutParameters->end_trigger);

			ai = CutParameters->end_lsp;

			if (ai)
				DelsHandyTeleportLara(ai->x, ai->y, ai->z, ai->y_rot);

			lara.holster = old_lara_holster;
			cutseq_trig = 0;
			GLOBAL_playing_cutseq = 0;
			finish_cutseq();
			camera.type = GLOBAL_oldcamtype;
			cutseq_num = 0;

			if (CutParameters->cinematic_bars)
				SetFadeClip(0, 1);

			AlterFOV(14560);
			StartTracks();
		}
	}
}

void do_new_cutscene_camera()
{
	PACKNODE* nodes;

	if (CutParameters->organizer)
		CallOrganizerTrigger(CutParameters->organizer, GLOBAL_cutseq_frame);

	if (GLOBAL_cutseq_frame < GLOBAL_numcutseq_frames)
		DecodeAnim(camera_pnodes, 2, GLOBAL_cutseq_frame, 0xFFFF);

	nodes = camera_pnodes;
	camera.target.y = nodes[0].yrot_run << 1;
	camera.pos.y = nodes[1].yrot_run << 1;

	switch (cutrot)
	{
	case 0:
		camera.target.x = nodes[0].xrot_run << 1;
		camera.target.z = nodes[0].zrot_run << 1;
		camera.pos.x = nodes[1].xrot_run << 1;
		camera.pos.z = nodes[1].zrot_run << 1;
		break;

	case 1:
		camera.target.x = nodes[0].zrot_run << 1;
		camera.target.z = -(nodes[0].xrot_run << 1);
		camera.pos.x = nodes[1].zrot_run << 1;
		camera.pos.z = -(nodes[1].xrot_run << 1);
		break;

	case 2:
		camera.target.x = -(nodes[0].xrot_run << 1);
		camera.target.z = -(nodes[0].zrot_run << 1);
		camera.pos.x = -(nodes[1].xrot_run << 1);
		camera.pos.z = -(nodes[1].zrot_run << 1);
		break;

	case 3:
		camera.target.x = -(nodes[0].zrot_run << 1);
		camera.target.z = nodes[0].xrot_run << 1;
		camera.pos.x = -(nodes[1].zrot_run << 1);
		camera.pos.z = nodes[1].xrot_run << 1;
		break;
	}

	camera.target.x += GLOBAL_cutme->orgx;
	camera.target.y += GLOBAL_cutme->orgy;
	camera.target.z += GLOBAL_cutme->orgz;
	camera.pos.x += GLOBAL_cutme->orgx;
	camera.pos.y += GLOBAL_cutme->orgy;
	camera.pos.z += GLOBAL_cutme->orgz;
	IsRoomOutsideNo = -1;
	IsRoomOutside(camera.pos.x, camera.pos.y, camera.pos.z);

	if (IsRoomOutsideNo != -1)
		camera.pos.room_number = IsRoomOutsideNo;

	if (GLOBAL_cutseq_frame < GLOBAL_numcutseq_frames)
		DecodeAnim(ext_pnodes, 1, GLOBAL_cutseq_frame, 0xFFFF);

	AlterFOV(ext_pnodes->yrot_run);
	phd_LookAt(camera.pos.x, camera.pos.y, camera.pos.z, camera.target.x, camera.target.y, camera.target.z, (ext_pnodes->xrot_run & 1023) << 6);

	if (GLOBAL_cutseq_frame < GLOBAL_numcutseq_frames)
	{
		if (GLOBAL_cutme->actor_data[0].objslot != NO_ITEM)
			DecodeAnim(actor_pnodes[0], 16, GLOBAL_cutseq_frame, 1023);

		for (int i = 1; i < GLOBAL_cutme->numactors; i++)
			DecodeAnim(actor_pnodes[i], GLOBAL_cutme->actor_data[i].nodes + 1, GLOBAL_cutseq_frame, 1023);
	}

	GLOBAL_cutseq_frame++;

	if (GLOBAL_cutseq_frame > GLOBAL_numcutseq_frames - 8 && cutseq_trig == 2)
		cutseq_trig = 3;

	if (GLOBAL_cutseq_frame > GLOBAL_numcutseq_frames)
		GLOBAL_cutseq_frame = GLOBAL_numcutseq_frames;
}

void InitPackNodes(NODELOADHEADER* lnode, PACKNODE* pnode, char* packed, long numnodes)
{
	long offset, xoff, yoff, zoff;

	offset = ((numnodes << 3) - numnodes) << 1;

	for (int i = 0; i < numnodes; i++)
	{
		pnode->xkey = (ushort)lnode->xkey;
		pnode->ykey = (ushort)lnode->ykey;
		pnode->zkey = (ushort)lnode->zkey;
		pnode->decode_x.packmethod = (lnode->packmethod >> 10) & 0xF;
		pnode->decode_y.packmethod = (lnode->packmethod >> 5) & 0xF;
		pnode->decode_z.packmethod = (lnode->packmethod) & 0xF;
		pnode->xlength = lnode->xlength;
		pnode->ylength = lnode->ylength;
		pnode->zlength = lnode->zlength;
		xoff = ((lnode->xlength * pnode->decode_x.packmethod) >> 3) + 4;
		yoff = ((lnode->ylength * pnode->decode_y.packmethod) >> 3) + 4;
		zoff = ((lnode->zlength * pnode->decode_z.packmethod) >> 3) + 4;
		lnode++;
		pnode->xpacked = &packed[offset];
		pnode->ypacked = &packed[offset + xoff];
		pnode->zpacked = &packed[offset + xoff + yoff];
		pnode++;
		offset += xoff + yoff + zoff;
	}
}

void frigup_lara()
{
	long* bone;

	if (GLOBAL_cutme->actor_data[0].objslot == NO_ITEM)
		return;

	bone = &bones[objects[lara_item->object_number].bone_index];
	updateAnimFrame(actor_pnodes[0], 16, temp_rotation_buffer);
	Rich_CalcLaraMatrices_Normal(temp_rotation_buffer, bone, 0);
	phd_PushUnitMatrix();
	Rich_CalcLaraMatrices_Normal(temp_rotation_buffer, bone, 1);
	phd_PopMatrix();
	HairControl(0, 0, temp_rotation_buffer);

	if (gfLevelFlags & GF_YOUNGLARA)
		HairControl(0, 1, temp_rotation_buffer);

	GLaraShadowframe = frig_shadow_bbox;
}

void updateAnimFrame(PACKNODE* node, int flags, short* frame)
{
	short* nex;
	short y;

	frame[7] = 3 * node->yrot_run;

	switch (cutrot)
	{
	case 0:
		frame[6] = 3 * node->xrot_run;
		frame[8] = 3 * node->zrot_run;
		break;

	case 1:
		frame[6] = 3 * node->zrot_run;
		frame[8] = -3 * node->xrot_run;
		break;

	case 2:
		frame[6] = -3 * node->xrot_run;
		frame[8] = -3 * node->zrot_run;
		break;

	case 3:
		frame[6] = -3 * node->zrot_run;
		frame[8] = 3 * node->xrot_run;
		break;
	}

	nex = frame + 9;

	for (int i = 1; i < flags; i++, nex += 2)
	{
		y = node[i].yrot_run;

		if (cutrot && i == 1)
			y = (y + (cutrot << 8)) & 0x3FF;

		nex[0] = (node[i].zrot_run | ((y | (node[i].xrot_run << 10)) << 10)) >> 16;
		nex[1] = node[i].zrot_run | ((y | (node[i].xrot_run << 10)) << 10);
	}
}

void* cutseq_malloc(long size)
{
	return game_malloc(size);
}

void finish_cutseq()
{
	AIOBJECT* ai;

	ai = CutParameters->init_lsp;

	if (ai)
	{
		GLOBAL_cutme->orgx = old_orgx;
		GLOBAL_cutme->orgy = old_orgy;
		GLOBAL_cutme->orgz = old_orgz;
	}

	if (GLOBAL_cutme->actor_data[0].objslot == NO_ITEM)
		lara_item->flags &= ~IFL_INVISIBLE;

	GLOBAL_playing_cutseq = 0;
	InitialiseHair();
}

long Load_and_Init_Cutseq(long num)
{
	AIOBJECT* ai;
	long* headerbuf;
	char* packed;
	long Offset;

	SetCutscene(num);
	headerbuf = (long*)cutseqpakPtr + (2 * num);
	Offset = headerbuf[0];
	packed = &cutseqpakPtr[Offset];
	GLOBAL_cutme = (NEW_CUTSCENE*)packed;
	ai = CutParameters->init_lsp;

	if (ai)
	{
		old_orgx = GLOBAL_cutme->orgx;
		old_orgy = GLOBAL_cutme->orgy;
		old_orgz = GLOBAL_cutme->orgz;
		GLOBAL_cutme->orgx = ai->x;
		GLOBAL_cutme->orgy = ai->y;
		GLOBAL_cutme->orgz = ai->z;
	}

	if (GLOBAL_cutme->actor_data[0].objslot == NO_ITEM)
		lara_item->flags |= IFL_INVISIBLE;

	init_cutseq_actors(packed, 0);
	return 0;
}

void init_cutseq_actors(char* data, long resident)
{
	CUTSCENE_DESCRIPTOR* cd;
	ITEM_INFO* item;
	char* packed;
	long pda_nodes, offset;

	GLOBAL_playing_cutseq = 0;
	GLOBAL_numcutseq_frames = GLOBAL_cutme->numframes;

	for (int i = 0; i < GLOBAL_cutme->numactors; i++)
	{
		item = &duff_item[i];
		offset = GLOBAL_cutme->actor_data[i].offset;
		packed = &data[offset];
		pda_nodes = GLOBAL_cutme->actor_data[i].nodes;
		actor_pnodes[i] = (PACKNODE*)cutseq_malloc((pda_nodes + 1) * sizeof(PACKNODE));

		if (i || GLOBAL_cutme->actor_data[0].objslot != NO_ITEM)
		{
			InitPackNodes((NODELOADHEADER*)packed, actor_pnodes[i], packed, pda_nodes + 1);
			DecodeAnim(actor_pnodes[i], pda_nodes + 1, 0, 1023);
		}

		memset(item, 0, sizeof(ITEM_INFO));
		item->il.ambient = lara_item->il.ambient;
		item->il.fcnt = -1;
		item->il.room_number = -1;
		item->il.RoomChange = 0;
		item->il.nCurrentLights = 0;
		item->il.nPrevLights = 0;
		item->il.pCurrentLights = &item->il.CurrentLights;
		item->il.pPrevLights = &item->il.PrevLights;
		item->pos.x_pos = GLOBAL_cutme->orgx;
		item->pos.y_pos = GLOBAL_cutme->orgy;
		item->pos.z_pos = GLOBAL_cutme->orgz;
		item->pos.x_rot = 0;
		item->pos.y_rot = 0;
		item->pos.z_rot = 0;
		item->room_number = 0;
	}

	offset = GLOBAL_cutme->camera_offset;
	packed = &data[offset];
	camera_pnodes = (PACKNODE*)cutseq_malloc(2 * sizeof(PACKNODE));
	InitPackNodes((NODELOADHEADER*)packed, camera_pnodes, packed, 2);
	DecodeAnim(camera_pnodes, 2, 0, 0xFFFF);
	cd = (CUTSCENE_DESCRIPTOR*)GLOBAL_cutme;
	offset = cd->ext;
	packed = &data[offset];
	ext_pnodes = (PACKNODE*)cutseq_malloc(sizeof(PACKNODE));
	InitPackNodes((NODELOADHEADER*)packed, ext_pnodes, packed, 1);
	DecodeAnim(ext_pnodes, 1, 0, 0xFFFF);
	GLOBAL_playing_cutseq = 1;
	GLOBAL_cutseq_frame = 0;
	DelsHandyTeleportLara(GLOBAL_cutme->orgx, GLOBAL_cutme->orgy, GLOBAL_cutme->orgz, 0);
	camera.pos.x = lara_item->pos.x_pos;
	camera.pos.y = lara_item->pos.y_pos;
	camera.pos.z = lara_item->pos.z_pos;
	camera.pos.room_number = lara_item->room_number;
	InitialiseHair();
}
